flclear fem

% Geometry
g1=circ2(0,0,1);
g2=circ2(0,0,2);
g3=g2-g1;
clear s
s.objs={g3};
s.name={'CO1'};
s.tags={'g3'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);
%figure
%geomplot(fem,'Edgelabels','on')
% Initialize mesh
fem.mesh=meshinit(fem);


% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.assignsuffix = '_hzeq';
clear bnd
bnd.expr = {'etavalue',{'eta(x,y)',''}};
bnd.type = {'dir','neu'};
bnd.r = {'etavalue',0};
bnd.g = {0,0}
bnd.ind = [1,1,2,2,1,2,2,1];
appl.bnd = bnd;
fem.appl{1} = appl;
fem.frame = {'ref'};
fem.border = 1;
fem.units = 'SI';

fem=multiphysics(fem);
% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
fem.sol=femlin(fem, ...
               'solcomp',{'u'}, ...
               'outcomp',{'u'});

