% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.2a (COMSOL 3.2.0.300, $Date: 2005/12/20 19:02:30 $)
clear all
flclear fem

% COMSOL version
clear vrsn
vrsn.name = 'COMSOL 3.2';
vrsn.ext = 'a';
vrsn.major = 0;
vrsn.build = 300;
vrsn.rcs = '$Name:  $';
vrsn.date = '$Date: 2005/12/20 19:02:30 $';
fem.version = vrsn;

% Geometry
disp('Initializing...')
clear draw
g1=circ2(2);
%g2=ellip2(1,0.4,'base','center','pos',[0,0]);%g2=circ2(1);
kort=imread('test.png');
kort=kort(:,:,1);
figure
image(kort);
colormap gray
[c,lr]=flim2curve(kort,{[],[0 255]}); %resolution is 255
%c=mirror(c,[0 1],[0 1]);

length(c)
c=solid2(c);
nvertices=geom1get(c,'nv')
c=scale(move(c,-0.5*length(kort),-0.5*length(kort)),1/nvertices,1/nvertices); %translate and scale
g4=g1-c;
geomplot(g4,'Pointmode','off')%,'edgelabels','on')
%g4=g1-kc;
draw.s.objs = {g4};
draw.s.name = {'CO1'};
draw.s.tags = {'g4'};
fem.draw = draw;
fem.geom = geomcsg(fem);
% Constants
fem.const = {'k','1'};

% Initialize mesh
fem.mesh=meshinit(fem);
hold on
meshplot(fem.mesh)
% Refine mesh
fem.mesh=meshrefine(fem, ...
                    'mcase',0, ...
                    'rmethod','regular');
%fem.mesh=meshrefine(fem, ...
%                    'mcase',0, ...
%                    'rmethod','regular');
%fem.mesh=meshrefine(fem, ...
%                    'mcase',0, ...
%                    'rmethod','regular');
fem.mesh		    
% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.assignsuffix = '_hzeq';
clear bnd
bnd.type = 'neu';
bnd.ind = [ones(1,nvertices+4)];
appl.bnd = bnd;
clear equ
equ.a = 'k^2';
equ.c = -1;
equ.f = 0;
equ.ind = [1];
appl.equ = equ;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'FlPDEWBoundary';
appl.dim = {'lm','lm_t'};
appl.assignsuffix = '_wb';
clear prop
clear weakconstr
weakconstr.value = 'off';
weakconstr.dim = {'lm2','lm3'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.weak = {'+(lm_test*(u-eta)+lm*(u_test-eta_test))-eta_test*deta',0};
bnd.usage = {1,0};
bnd.ind = [1,1,1,1,2*ones(1,nvertices)];
appl.bnd = bnd;
fem.appl{2} = appl;
fem.frame = {'ref'};
fem.border = 1;
fem.units = 'SI';

% Scalar expressions
fem.expr = {'r','sqrt(x^2+y^2)', ...
  'theta','atan2(y,x)', ...
   'eta','etaterm(0,k,theta,r,g0,z0)+etaterm(1,k,theta,r,g1,z1)+etaterm(2,k,theta,r,g2,z2)+etaterm(3,k,theta,r,g3,z3)+etaterm(4,k,theta,r,g4,z4)+etaterm(5,k,theta,r,g5,z5)+etaterm(6,k,theta,r,g6,z6)+etaterm(7,k,theta,r,g7,z7)+etaterm(8,k,theta,r,g8,z8)+etaterm(9,k,theta,r,g9,z9)+exp(i*k*x)',...      %g0*etacos(0,k,theta,r)+g1*etacos(1,k,theta,r)+g2*etacos(2,k,theta,r)+g3*etacos(3,k,theta,r)+g4*et%acos(4,k,theta,r)+g5*etacos(5,k,theta,r)+g6*etacos(6,k,theta,r)+g7*etacos(7,k,theta,r)+g8*etacos(%8,k,theta,r)+g9*etacos(9,k,theta,r)+z0*etasin(0,k,theta,r)+z1*etasin(1,k,theta,r)+z2*etasin(2,k,t%heta,r)+z3*etasin(3,k,theta,r)+z4*etasin(4,k,theta,r)+z5*etasin(5,k,theta,r)+z6*etasin(6,k,theta,%r)+z7*etasin(7,k,theta,r)+z8*etasin(8,k,theta,r)+z9*etasin(9,k,theta,r)+exp(i*k*x)', ...
'deta','diff(etaterm(0,k,theta,r,g0,z0))+diff(etaterm(1,k,theta,r,g1,z1))+diff(etaterm(2,k,theta,r,g2,z2))+diff(etaterm(3,k,theta,r,g3,z3))+diff(etaterm(4,k,theta,r,g4,z4))+diff(etaterm(5,k,theta,r,g5,z5))+diff(etaterm(6,k,theta,r,g6,z6))+diff(etaterm(7,k,theta,r,g7,z7))+diff(etaterm(8,k,theta,r,g8,z8))+diff(etaterm(9,k,theta,r,g9,z9))+i*k*cos(theta)*exp(i*k*x)'};   %'deta','g0*diff(etacos(0,k,theta,r),r)+g1*diff(etacos(1,k,theta,r),r)+g2*diff(etacos(2,k,theta,r)%,r)+g3*diff(etacos(3,k,theta,r),r)+g4*diff(etacos(4,k,theta,r),r)+g5*diff(etacos(5,k,theta,r),r)+%g6*diff(etacos(6,k,theta,r),r)+g7*diff(etacos(7,k,theta,r),r)+g8*diff(etacos(8,k,theta,r),r)+g9*d%iff(etacos(9,k,theta,r),r)+z0*diff(etasin(0,k,theta,r),r)+z1*diff(etasin(1,k,theta,r),r)+z2*diff(%etasin(2,k,theta,r),r)+z3*diff(etasin(3,k,theta,r),r)+z4*diff(etasin(4,k,theta,r),r)+z5*diff(etas%in(5,k,theta,r),r)+z6*diff(etasin(6,k,theta,r),r)+z7*diff(etasin(7,k,theta,r),r)+z8*diff(etasin(8%,k,theta,r),r)+z9*diff(etasin(9,k,theta,r),r)+i*k*cos(theta)*exp(i*k*x)'};

% Functions
clear fcns
%cosine part
fcns{1}.type='inline';
fcns{1}.name='etaterm(n,k,theta,r,g,z)';
fcns{1}.expr='besselh(n,1,k*r)*(g*cos(n*theta)+z*sin(n*theta)';
fcns{1}.dexpr={'0','0','0', ...
  '(-k*besselh(n+1,1,k*r)+n/r*besselh(n,1,k*r))*(g*cos(n*theta)+z*sin(n*theta),0,0'};
fcns{1}.complex='true';

%sine part
%fcns{2}.type='inline';
%fcns{2}.name='etasin(n,k,theta,r)';
%fcns{2}.expr='besselh(n,1,k*r)*sin(n*theta)';
%fcns{2}.dexpr={'0','0','0', ...
%  '(-k*besselh(n+1,1,k*r)+n/r*besselh(n,1,k*r))*sin(n*theta)'};
%fcns{2}.complex='true';

fem.functions = fcns;

% ODE Settings
clear ode
ode.dim={'g0','g1','g2','g3','g4','g5','g6','g7','g8','g9','z9','z8','z7','z6','z5','z4','z3','z2','z1','z0'};
ode.f={'0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0'};
ode.init={'0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0'};
ode.dinit={'0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0','0'};
fem.ode=ode;
% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem);

% Solve problem
disp('Solving problem')
fem.sol=femlin(fem, ...
               'complexfun','on', ...
               'solcomp',{'z9','z8','z7','z6','z5','z4','z3','z2','z1','z0','g9','g8','g7','g6','g5','g4','g3','g2','g1','lm','u','g0'}, ...
               'outcomp',{'z0','z1','z2','z3','z4','z5','z6','z7','z8','z9','g9','g8','g7','g6','g5','g4','g3','g2','g1','lm','u','g0'});

% Save current fem structure for restart purposes
fem0=fem;

% Plot solution
figure
postplot(fem, ...
         'tridata',{'abs(u)','cont','internal'}, ...
         'trimap','jet(1024)', ...
         'title','Surface: u', ...
         'axis',[-5.7956416464891,5.7956416464891,-2.2,2.2,-1,1]);

%Save solution
u0=fem.sol.u(:);

disp('Extracting coefficients')
%Initialize the system with zeroes except the ODE variables
fem.equ.init={'0','0'};
fem.ode.init={'1','2','3','4','5','6','7','8','9','10','1','2','3','4','5','6','7','8','9','10'};

%Extend mesh
fem.xmesh=meshextend(fem);

%Initialize the solution vector
fem.sol=asseminit(fem,'out','u');

% Locate the position of the ODE variables and display their value.
disp('Numerical G_n from Comsol')
for i = 1:length(fem.ode.init)
eta_n_index(i) = find(fem.sol == i);
disp(['eta' num2str(i-1) ': ' num2str(u0(eta_n_index(i))) ...
' ,abs: ' num2str(abs(u0(eta_n_index(i))))])
end
% Insert the true solution back into the fem struct
fem.sol = asseminit(fem,'init',u0);



