% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.2a (COMSOL 3.2.0.300, $Date: 2005/12/20 19:02:30 $)

flclear fem

% COMSOL version
clear vrsn
vrsn.name = 'COMSOL 3.2';
vrsn.ext = 'a';
vrsn.major = 0;
vrsn.build = 300;
vrsn.rcs = '$Name:  $';
vrsn.date = '$Date: 2005/12/20 19:02:30 $';
fem.version = vrsn;

% Geometry
g1=circ2('1','base','center','pos',{'0','0'},'rot','0');
g2=circ2('2','base','center','pos',{'0','0'},'rot','0');
g3=geomcomp({g1,g2},'ns',{'C1','C2'},'sf','C2-C1','edge','none');
clear s
s.objs={g3};
s.name={'CO1'};
s.tags={'g3'};

fem.draw=struct('s',s);
fem.geom=geomcsg(fem);

% Constants
fem.const = {'k','1'};

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.assignsuffix = '_hzeq';
clear bnd
bnd.type = 'neu';
bnd.ind = [1,1,1,1,1,1,1,1];
appl.bnd = bnd;
clear equ
equ.a = 'k^2';
equ.c = -1;
equ.f = 0;
equ.ind = [1];
appl.equ = equ;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'FlPDEWBoundary';
appl.dim = {'lm','lm_t'};
appl.assignsuffix = '_wb';
clear prop
clear weakconstr
weakconstr.value = 'off';
weakconstr.dim = {'lm2','lm3'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.weak = {'+(lm_test*(u-eta)+lm*(u_test-eta_test))-eta_test*deta',0};
bnd.usage = {1,0};
bnd.ind = [1,1,2,2,1,2,2,1];
appl.bnd = bnd;
fem.appl{2} = appl;
fem.frame = {'ref'};
fem.border = 1;
fem.units = 'SI';

% Scalar expressions
fem.expr = {'r','sqrt(x^2+y^2)', ...
  'theta','atan2(y,x)', ...
  'eta','g0*etaterm(r,theta,k,0)+g1*coupledsolution(r,theta,k,1)+exp(i*k*x)', ...
  'deta','g0*diff(etaterm(r,theta,k,0),r)+g1*diff(etaterm(r,theta,k,1))+i*k*cos(theta)*exp(i*k*x)'};

% Functions
clear fcns
fcns{1}.type='inline';
fcns{1}.name='etaterm(r,theta,k,n)';
fcns{1}.expr='besselh(n,1,k*r)*cos(n*theta)';
fcns{1}.dexpr={'0','0','0', ...
  '(-k*besselh(n+1,1,k*r)+n/r*besselh(n,1,k*r))*cos(n*theta)'};
fcns{1}.complex='true';
fem.functions = fcns;

% ODE Settings
clear ode
ode.dim={'g0','g1'};
ode.f={'0','0'};
ode.init={'0','0'};
ode.dinit={'0','0'};
fem.ode=ode;
% Multiphysics
fem=multiphysics(fem);

% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.2a (COMSOL 3.2.0.300, $Date: 2005/12/20 19:02:30 $)

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'Helmholtz';
appl.assignsuffix = '_hzeq';
clear bnd
bnd.type = 'neu';
bnd.ind = [1,1,1,1,1,1,1,1];
appl.bnd = bnd;
clear equ
equ.a = 'k^2';
equ.c = -1;
equ.f = 0;
equ.ind = [1];
appl.equ = equ;
fem.appl{1} = appl;

% Application mode 2
clear appl
appl.mode.class = 'FlPDEWBoundary';
appl.dim = {'lm','lm_t'};
appl.assignsuffix = '_wb';
clear prop
clear weakconstr
weakconstr.value = 'off';
weakconstr.dim = {'lm2','lm3'};
prop.weakconstr = weakconstr;
appl.prop = prop;
clear bnd
bnd.weak = {'+(lm_test*(u-eta)+lm*(u_test-eta_test))-eta_test*deta',0};
bnd.usage = {1,0};
bnd.ind = [1,1,2,2,1,2,2,1];
appl.bnd = bnd;
fem.appl{2} = appl;
fem.frame = {'ref'};
fem.border = 1;
fem.units = 'SI';

% Scalar expressions
fem.expr = {'r','sqrt(x^2+y^2)', ...
  'theta','atan2(y,x)', ...
  'eta','g0*etaterm(r,theta,k,0)+g1*coupledsolution(r,theta,k,1)+exp(i*k*x)', ...
  'deta','g0*diff(etaterm(r,theta,k,0),r)+g1*diff(etaterm(r,theta,k,1))+i*k*cos(theta)*exp(i*k*x)'};

% Functions
clear fcns
fcns{1}.type='inline';
fcns{1}.name='etaterm(r,theta,k,n)';
fcns{1}.expr='besselh(n,1,k*r)*cos(n*theta)';
fcns{1}.dexpr={'0','0','0', ...
  '(-k*besselh(n+1,1,k*r)+n/r*besselh(n,1,k*r))*cos(n*theta)'};
fcns{1}.complex='true';
fcns{2}.type='inline';
fcns{2}.name='etatermsin(r,theta,k,n)';
fcns{2}.expr='besselh(n,1,k*r)*sin(n*theta)';
fcns{2}.dexpr={'0','0','0', ...
  '(-k*besselh(n+1,1,k*r)+n/r*besselh(n,1,k*r))*sin(n*theta)'};
fem.functions = fcns;

% ODE Settings
clear ode
ode.dim={'g0','g1','z1','z2'};
ode.f={'0','0','0','0'};
ode.init={'0','0','0','0'};
ode.dinit={'0','0','0','0'};
fem.ode=ode;
% Multiphysics
fem=multiphysics(fem);
